summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Andreas Guldstrand <andreas.guldstrand@gmail.com>2014-04-12 00:23:03 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2014-04-12 00:23:03 +0700
commitbb3ef6edd949aff15e8bfe66bce9771bd47b28ce (patch)
tree639eb2094fd664c2ad96bf020725f96a3a49b204 /development
parentf957860309619b6ceaf55fa29e33f0409e40b964 (diff)
downloadslackbuilds-bb3ef6edd949aff15e8bfe66bce9771bd47b28ce.tar.gz
slackbuilds-bb3ef6edd949aff15e8bfe66bce9771bd47b28ce.tar.xz
development/perf: Added (Linux kernel perf tools).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/perf/README12
-rw-r--r--development/perf/perf.SlackBuild99
-rw-r--r--development/perf/perf.info10
-rw-r--r--development/perf/slack-desc19
4 files changed, 140 insertions, 0 deletions
diff --git a/development/perf/README b/development/perf/README
new file mode 100644
index 0000000000..3eaadb7db3
--- /dev/null
+++ b/development/perf/README
@@ -0,0 +1,12 @@
+perf is a userspace interface to the kernel's perf events. Performance
+counters are CPU hardware registers that count hardware events such as
+instructions executed, cache-misses suffered, or branches mispredicted. They
+form a basis for profiling applications to trace dynamic control flow and
+identify hotspots.
+
+Please note that this SBo doesn't have any sources in the DOWNLOAD
+setting, as the sources are already part of a full slackware install.
+
+Optional dependencies: audit, numactl
+Another optional dependency is libunwind, but it's unsupported for now
+since it requires elfutils which we don't have yet on SBO.
diff --git a/development/perf/perf.SlackBuild b/development/perf/perf.SlackBuild
new file mode 100644
index 0000000000..3300137091
--- /dev/null
+++ b/development/perf/perf.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# Slackware build script for perf
+
+# Copyright 2014, Andreas Guldstrand <andreas.guldstrand@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=perf
+VERSION=${VERSION:-3.10.17}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+SRCDIR="/usr/src/linux-$VERSION/tools"
+BUILDDIR=$TMP/$PRGNAM-$VERSION
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $BUILDDIR
+
+mkdir -p $BUILDDIR/lib/lk
+cd $BUILDDIR
+make -C $SRCDIR/lib/lk/ O=$BUILDDIR/lib/lk
+# We need -DSILENT_NO_TAINT_SUPPORT=0, -DNO_TAINT_SUPPORT=0, and
+# -Wno-strict-default to compile together with perl 5.18+
+make -C $SRCDIR/ perf_install O=$BUILDDIR DESTDIR=$PKG/ \
+ mandir=/usr/man/ perfexecdir=/usr/libexec/perf-core \
+ CFLAGS="-DSILENT_NO_TAINT_SUPPORT=0 -DNO_TAINT_SUPPORT=0" \
+ -Wno-strict-default
+
+mkdir $PKG/usr/bin
+mv $PKG/bin/perf $PKG/usr/bin/perf
+rm -rf $PKG/bin
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+DOCDIR=$PKG/usr/doc/$PRGNAM-$VERSION
+mkdir -p $DOCDIR/Documentation
+
+cp -a $SRCDIR/perf/command-list.txt $SRCDIR/perf/design.txt \
+ $SRCDIR/perf/CREDITS $SRCDIR/../COPYING $DOCDIR
+cp -a $SRCDIR/perf/Documentation/*.txt $DOCDIR/Documentation
+cat $CWD/$PRGNAM.SlackBuild > $DOCDIR/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/perf/perf.info b/development/perf/perf.info
new file mode 100644
index 0000000000..47a1d618f9
--- /dev/null
+++ b/development/perf/perf.info
@@ -0,0 +1,10 @@
+PRGNAM="perf"
+VERSION="3.10.17"
+HOMEPAGE="https://perf.wiki.kernel.org/index.php/Main_Page"
+DOWNLOAD="http://www.pastemobile.org/perf.dummy"
+MD5SUM="9cba6c70fb57a22a155073d54748b614"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Andreas Guldstrand"
+EMAIL="andreas.guldstrand@gmail.com"
diff --git a/development/perf/slack-desc b/development/perf/slack-desc
new file mode 100644
index 0000000000..fa75ae0024
--- /dev/null
+++ b/development/perf/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+perf: perf (Linux kernel perf tools)
+perf:
+perf: perf is a userspace interface to the kernel's perf events.
+perf: Performance counters are CPU hardware registers that count hardware
+perf: events such as instructions executed, cache-misses suffered, or
+perf: branches mispredicted.
+perf: They form a basis for profiling applications to trace dynamic control
+perf: flow and identify hotspots.
+perf:
+perf:
+perf: